/* Code for implementing pipelined processor simulators */

typedef struct {
  /* Current and next register state */
  void *current;
  void *next;
  /* Number of state bytes */
  int count;
  /* Should state be set to zero on next update? */
  int bubble;
  /* Should I keep state same on next update? */
  int stall;
} stage_ele, *stage_ptr;

/* Create new stage with count bytes of state */
stage_ptr new_stage(int count);

/* Update all stages */
void update_stages();

/* Utility code */
void wprint(unsigned x, int bpd, int bpw, FILE *fp);

void dump_state(unsigned *state, char **text, int count, FILE *fp);

unsigned load_state(unsigned *state, char **text, FILE *fp);

unsigned clear_state(unsigned *state, int count);

